summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
author Thiago Nascimento <nascimenthiago@gmail.com>2015-02-28 11:16:30 +0700
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2015-02-28 11:16:30 +0700
commit27d4a7b86aee4de9b2e7d7f03812ce12f9c835e9 (patch)
treee2a4443996ebcfa36b3b1c58be3401075d1afd7c
parent9bac66e8b9b2cbc8265f22e7310d433dfe24b395 (diff)
downloadslackbuilds-27d4a7b86aee4de9b2e7d7f03812ce12f9c835e9.tar.gz
slackbuilds-27d4a7b86aee4de9b2e7d7f03812ce12f9c835e9.tar.xz
academic/armadillo: Added (C++ linear algebra library).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
-rw-r--r--academic/armadillo/README20
-rw-r--r--academic/armadillo/armadillo.SlackBuild108
-rw-r--r--academic/armadillo/armadillo.info10
-rw-r--r--academic/armadillo/slack-desc19
4 files changed, 157 insertions, 0 deletions
diff --git a/academic/armadillo/README b/academic/armadillo/README
new file mode 100644
index 0000000000..4f4df4bec5
--- /dev/null
+++ b/academic/armadillo/README
@@ -0,0 +1,20 @@
+Armadillo is a high quality C++ linear algebra library useful
+for development of algorithms in machine learning, pattern recognition,
+signal processing, bioinformatics, statistics, etc.
+
+Armadillo makes extensive use of template meta-programming, recursive templates
+and template based function overloading. As such, C++ compilers which do not
+fully implement the C++ standard may not work correctly.
+
+The functionality of Armadillo is partly dependent on other libraries:
+LAPACK, BLAS and ARPACK. The LAPACK and BLAS libraries are used for
+dense matrices, while the ARPACK library is used for sparse matrices.
+Armadillo can work without these libraries, but its functionality
+will be reduced. In particular, basic functionality will be available
+(eg. matrix addition and multiplication), but things like eigen
+decomposition or matrix inversion will not be. Matrix multiplication
+(mainly for big matrices) may not be as fast.
+
+As Armadillo is a template library, we recommended that optimisation
+is enabled during compilation of programs that use Armadillo.
+For example, for GCC and Clang compilers use -O2 or -O3
diff --git a/academic/armadillo/armadillo.SlackBuild b/academic/armadillo/armadillo.SlackBuild
new file mode 100644
index 0000000000..17831f3d39
--- /dev/null
+++ b/academic/armadillo/armadillo.SlackBuild
@@ -0,0 +1,108 @@
+#!/bin/sh
+
+# Slackware build script for Armadillo
+
+# Copyright 2015 Thiago Nascimento <nascimenthiago@gmail.com>, Brazil
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=armadillo
+VERSION=${VERSION:-4.650.2}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+DOCS="README.txt examples/ index.html LICENSE.txt docs.html rcpp_armadillo_csda_2014.pdf"
+
+if [-z "$ARCH" ]; then
+ case "$(uname -m)" in
+ i?86) ARCH=i486 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$(uname -m) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+mkdir -p build
+cd build
+ cmake \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DCMAKE_BUILD_TYPE=Release ..
+ make
+ make install DESTDIR=$PKG
+cd ..
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/academic/armadillo/armadillo.info b/academic/armadillo/armadillo.info
new file mode 100644
index 0000000000..f8d4345459
--- /dev/null
+++ b/academic/armadillo/armadillo.info
@@ -0,0 +1,10 @@
+PRGNAM="armadillo"
+VERSION="4.650.2"
+HOMEPAGE="http://arma.sourceforge.net/"
+DOWNLOAD="http://sourceforge.net/projects/arma/files/armadillo-4.650.2.tar.gz"
+MD5SUM="c8e5c94e5d3753fa5cdb2080598ccdfb"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="Thiago Nascimento"
+EMAIL="nascimenthiago@gmail.com"
diff --git a/academic/armadillo/slack-desc b/academic/armadillo/slack-desc
new file mode 100644
index 0000000000..5f4f070529
--- /dev/null
+++ b/academic/armadillo/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+armadillo: Armadillo (C++ linear algebra library)
+armadillo:
+armadillo: Armadillo is a high quality C++ linear algebra library, aiming towards
+armadillo: balance between speed and ease of use; the syntax (API) is deliberately
+armadillo: similar to Matlab.
+armadillo:
+armadillo: Homepage: http://arma.sourceforge.net
+armadillo:
+armadillo:
+armadillo:
+armadillo: